import { numeral } from '@core-foundation/numeral';

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);

    if (enumerableOnly) {
      symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    }

    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

var _Symbol$iterator;
_Symbol$iterator = Symbol.iterator;

/**
 * Class to manage the lower and upper boundary of a target value
 */
var NumericRange = /*#__PURE__*/function (_Symbol$iterator2) {
  /**
   * The mininum value of the range
   */

  /**
   * The maximum value of the range
   */

  /**
   * The precision or decimal count of the range's value
   */

  /**
   * The step value of the range
   */

  /**
   * The precision of the range's step
   */

  /**
   * The `value` of the range
   */

  /* -----------------------------------------------------------------------------
   * Creating a numeric range
   * -----------------------------------------------------------------------------*/

  /**
   * Initializes a new instance of the NumericRange class
   */
  function NumericRange(options) {
    var _this = this;

    _classCallCheck(this, NumericRange);

    this.options = options;

    _defineProperty(this, "min", void 0);

    _defineProperty(this, "max", void 0);

    _defineProperty(this, "precision", void 0);

    _defineProperty(this, "step", void 0);

    _defineProperty(this, "stepPrecision", void 0);

    _defineProperty(this, "value", void 0);

    _defineProperty(this, "clone", function () {
      return new NumericRange(_this);
    });

    _defineProperty(this, "withOptions", function (options) {
      return new NumericRange(_objectSpread2(_objectSpread2({}, _this.options), options));
    });

    _defineProperty(this, "valueOf", function () {
      return NumericRange.parse(_this.value);
    });

    _defineProperty(this, "toString", function () {
      var num = _this.valueOf();

      return numeral(num).toFixed(_this._precision);
    });

    _defineProperty(this, "toJSON", function () {
      var min = _this.min,
          max = _this.max,
          value = _this.value;
      return {
        min: min,
        max: max,
        value: value
      };
    });

    _defineProperty(this, "setValueFromPercent", function (percent) {
      var _NumericRange$fromPer = NumericRange.fromPercent(percent, _this),
          value = _NumericRange$fromPer.value;

      _this.value = value;
      return _this;
    });

    _defineProperty(this, "setValue", function (value) {
      _this.value = value;
      return _this;
    });

    _defineProperty(this, "setStep", function (step) {
      _this.step = step;
      return _this;
    });

    _defineProperty(this, "setToMin", function () {
      _this.value = _this.min.toString();
      return _this;
    });

    _defineProperty(this, "setToMax", function () {
      _this.value = _this.max.toString();
      return _this;
    });

    _defineProperty(this, "toPercent", function () {
      return (_this.valueOf() - _this.min) * 100 / (_this.max - _this.min);
    });

    _defineProperty(this, "clamp", function () {
      var value = _this.valueOf();

      value = Math.min(Math.max(value, _this.min), _this.max);
      _this.value = numeral(value).toFixed(_this.precision);
      return _this;
    });

    _defineProperty(this, "toPrecision", function () {
      _this.value = numeral(_this.valueOf()).toFixed(_this._precision);
      return _this;
    });

    _defineProperty(this, "increment", function () {
      var step = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.step;

      if (_this.value === "") {
        _this.value = NumericRange.parse(step);
      } else {
        _this.value = _this.valueOf() + step;
      }

      return _this;
    });

    _defineProperty(this, "decrement", function () {
      var step = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.step;

      if (_this.value === "") {
        _this.value = NumericRange.parse(-step);
      } else {
        _this.value = _this.valueOf() - step;
      }

      return _this;
    });

    _defineProperty(this, "snapToStep", function () {
      var value = _this.valueOf();

      var precision = _this.stepPrecision;

      var v = Math.round(value / _this.step) * _this.step;

      _this.value = numeral(v).toFixed(precision);
      return _this;
    });

    _defineProperty(this, "reset", function () {
      var _this$options = _this.options,
          _this$options$value = _this$options.value,
          value = _this$options$value === void 0 ? 0 : _this$options$value,
          _this$options$step = _this$options.step,
          step = _this$options$step === void 0 ? 1 : _this$options$step,
          _this$options$min = _this$options.min,
          min = _this$options$min === void 0 ? 0 : _this$options$min,
          _this$options$max = _this$options.max,
          max = _this$options$max === void 0 ? 100 : _this$options$max,
          precision = _this$options.precision;
      Object.assign(_this, {
        value: value,
        step: step,
        min: min,
        max: max,
        precision: precision
      });
      return _this;
    });

    var _options$min = options.min,
        _min = _options$min === void 0 ? 0 : _options$min,
        _options$max = options.max,
        _max = _options$max === void 0 ? 100 : _options$max,
        _precision = options.precision,
        _options$step = options.step,
        _step = _options$step === void 0 ? 1 : _options$step,
        _options$value = options.value,
        _value = _options$value === void 0 ? 0 : _options$value;

    if (_max < _min) {
      throw new RangeError("clamp: max cannot be less than min");
    }

    this.min = _min;
    this.max = _max;
    this.value = _value;
    this.precision = _precision;
    this.step = _step;
    this.stepPrecision = numeral(_step).decimals;
  }
  /**
   * Creates a range based on the specified `[min, max]` tuple
   */


  _createClass(NumericRange, [{
    key: _Symbol$iterator2,
    value:
    /*#__PURE__*/

    /**
     * Converts numeric range to iterable to support `for..of` loop,
     * spread operator, and `Array.from(...)`
     */
    regeneratorRuntime.mark(function value() {
      var current;
      return regeneratorRuntime.wrap(function value$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              current = this.min;

            case 1:
              if (!(current <= this.max)) {
                _context.next = 7;
                break;
              }

              _context.next = 4;
              return current;

            case 4:
              current += this.step;
              _context.next = 1;
              break;

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, value, this);
    })
    /* -----------------------------------------------------------------------------
     * Numeric range Properties
     * -----------------------------------------------------------------------------*/

    /**
     * Whether the `value` is within the `min` and `max`
     */

  }, {
    key: "isInRange",
    get: function get() {
      var value = this.value === "" ? 0 : this.valueOf();
      return value <= this.max && value >= this.min;
    }
    /**
     * Whether the `value` is at `min`
     */

  }, {
    key: "isAtMin",
    get: function get() {
      return this.valueOf() === this.min;
    }
    /**
     * Whether the `value` is at `max`
     */

  }, {
    key: "isAtMax",
    get: function get() {
      return this.valueOf() === this.max;
    }
    /**
     * Get the decimal count of the range's value
     */

  }, {
    key: "_precision",
    get: function get() {
      var _this$precision;

      var num = this.valueOf();
      var precision = Number.isNaN(num) ? this.stepPrecision : Math.max(numeral(num).decimals, this.stepPrecision);
      return (_this$precision = this.precision) !== null && _this$precision !== void 0 ? _this$precision : precision;
    }
    /**
     * Converts a string value to a number and strips letters
     */

  }]);

  return NumericRange;
}(_Symbol$iterator);

_defineProperty(NumericRange, "fromTuple", function (tuple) {
  var _tuple = _slicedToArray(tuple, 2),
      min = _tuple[0],
      max = _tuple[1];

  return new NumericRange({
    min: min,
    max: max
  });
});

_defineProperty(NumericRange, "create", function (min, max, value) {
  return new NumericRange({
    min: min,
    max: max,
    value: value
  });
});

_defineProperty(NumericRange, "fromValues", function (values) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var _options$min2 = options.min,
      min = _options$min2 === void 0 ? 0 : _options$min2,
      _options$max2 = options.max,
      max = _options$max2 === void 0 ? 100 : _options$max2;
  return values.map(function (value, i) {
    var _values, _values2;

    return [(_values = values[i - 1]) !== null && _values !== void 0 ? _values : min, (_values2 = values[i + 1]) !== null && _values2 !== void 0 ? _values2 : max, value];
  }).map(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 3),
        min = _ref2[0],
        max = _ref2[1],
        value = _ref2[2];

    return new NumericRange({
      min: min,
      max: max,
      value: value
    });
  });
});

_defineProperty(NumericRange, "fromPercent", function (percent) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var _options$min3 = options.min,
      min = _options$min3 === void 0 ? 0 : _options$min3,
      _options$max3 = options.max,
      max = _options$max3 === void 0 ? 100 : _options$max3;
  var value = (max - min) * percent + min;
  return new NumericRange({
    min: min,
    max: max,
    value: value
  });
});

_defineProperty(NumericRange, "parse", function (value) {
  return parseFloat(value.toString().replace(/[^\w.-]+/g, ""));
});

_defineProperty(NumericRange, "transform", function (inputTuple, outputTuple) {
  var input = NumericRange.fromTuple(inputTuple);
  var output = NumericRange.fromTuple(outputTuple);
  return function (value) {
    if (input.min === input.max || output.min === output.max) {
      return output.min;
    }

    var ratio = (output.max - output.min) / (input.max - input.min);
    return output.min + ratio * (value - input.min);
  };
});

export { NumericRange };
